import { Chip, Stack, StackOwnProps, Theme, Typography, useTheme, withTheme } from "@mui/material";
import React from "react";
import { Bus } from "./Bus";
import { range } from "@/utils/Range";

export interface BusesListProps {
  physical: number;
  virtual: number;
  width: number;
  stackProps?: StackOwnProps
}
export interface BusesListState {
}

export class BusesList extends React.Component<BusesListProps, BusesListState> {
  constructor(props: BusesListProps) {
    super(props);
  }
  mapCallback(
    ...args: Parameters<
      Parameters<Parameters<typeof Array<number>>["map"]>["0"]
    >
  ) {
    const [busId] = args;
    const isPhysical = busId < this.props.physical;
    const name = `${isPhysical ? "A" : "B"}${
          isPhysical ? busId + 1 : busId - this.props.physical + 1
        }`;
    return (
      <Stack direction={"row"} sx={{width:"100%"}} alignItems={"center"}
        key={name}
      >
        {/* <Chip variant="outlined" sx={{marginInlineEnd: "15px"}} label={name}/> */}
        <Bus width={this.props.width} name={name} onChange={console.log} />
      </Stack>
    );
  }
  render(): React.ReactNode {
    if (this.props.width > 800) {
      return (
        <Stack {...this.props.stackProps} direction={"row"} spacing={this.props.width > 1200 ? 4 : 2}>
          <Stack sx={{ width: "50%" }}>
            {range(this.props.physical).map(this.mapCallback.bind(this))}
          </Stack>
          <Stack sx={{ width: "50%" }}>
            {range(this.props.virtual, this.props.physical).map(
              this.mapCallback.bind(this)
            )}
          </Stack>
        </Stack>
      );
    }
    return (
      <Stack {...this.props.stackProps}>
        {range(this.props.physical + this.props.virtual).map(
          this.mapCallback.bind(this)
        )}
      </Stack>
    );
  }
}
